libstdc++: __gnu_cxx::rb_tree< _Key, _Value, _KeyOfValue, _Compare, _Alloc > Struct Template Reference

libstdc++

__gnu_cxx::rb_tree< _Key, _Value, _KeyOfValue, _Compare, _Alloc > Struct Template Reference
Extensions » SGI

`#include <rb_tree>`

## Public Types
template<typename _Iter>
using | __same_value_type
typedef std::_Rb_tree< _Key, _Value, _KeyOfValue, _Compare, _Alloc > | _Base
typedef _Base::allocator_type | allocator_type
typedef _Node_traits::_Const_iterator | const_iterator
typedef const value_type * | const_pointer
typedef const value_type & | const_reference
typedef std::reverse_iterator< const_iterator > | const_reverse_iterator
typedef ptrdiff_t | difference_type
typedef _Node_traits::_Iterator | iterator
typedef _Key | key_type
typedef value_type * | pointer
typedef value_type & | reference
typedef std::reverse_iterator< iterator > | reverse_iterator
typedef size_t | size_type
typedef _Val | value_type

## Public Member Functions
| rb_tree (const _Compare &__comp=_Compare(), const allocator_type &__a=allocator_type())
bool | __rb_verify () const
template<typename _Iterator>
void | _M_assign_equal (_Iterator, _Iterator)
template<typename _Iterator>
void | _M_assign_unique (_Iterator, _Iterator)
template<typename... _Args>
iterator | _M_emplace_equal (_Args &&... __args)
template<typename... _Args>
iterator | _M_emplace_here (bool __place_left, _Base_ptr __node, _Args &&... __args)
template<typename... _Args>
iterator | _M_emplace_hint_equal (const_iterator __pos, _Args &&... __args)
template<typename... _Args>
iterator | _M_emplace_hint_unique (const_iterator __pos, _Args &&... __args)
template<typename... _Args>
pair< iterator, bool > | _M_emplace_unique (_Args &&... __args)
template<typename _Kt>
size_type | _M_erase_tr (const _Kt &__x)
size_type | _M_erase_unique (const key_type &__x)
pair< _Base_ptr, _Base_ptr > | _M_get_insert_equal_pos (const key_type &__k)
pair< _Base_ptr, _Base_ptr > | _M_get_insert_hint_equal_pos (const_iterator __pos, const key_type &__k)
pair< _Base_ptr, _Base_ptr > | _M_get_insert_hint_unique_pos (const_iterator __pos, const key_type &__k)
template<typename _Kt>
pair< _Base_ptr, _Base_ptr > | _M_get_insert_hint_unique_pos_tr (const_iterator, const _Kt &__k)
pair< _Base_ptr, _Base_ptr > | _M_get_insert_unique_pos (const key_type &__k)
template<typename _Kt>
pair< _Base_ptr, _Base_ptr > | _M_get_insert_unique_pos_tr (const _Kt &__k)
const _Node_allocator & | _M_get_Node_allocator () const noexcept
_Node_allocator & | _M_get_Node_allocator () noexcept
template<typename _Arg>
iterator | _M_insert_equal (_Arg &&__x)
template<typename _Arg>
iterator | _M_insert_equal_ (const_iterator __pos, _Arg &&__x)
template<typename _Arg, typename _NodeGen>
iterator | _M_insert_equal_ (const_iterator __pos, _Arg &&__x, _NodeGen &)
template<typename _InputIterator>
__enable_if_t<!__same_value_type< _InputIterator >::value > | _M_insert_range_equal (_InputIterator __first, _InputIterator __last)
template<typename _InputIterator>
__enable_if_t< __same_value_type< _InputIterator >::value > | _M_insert_range_equal (_InputIterator __first, _InputIterator __last)
template<typename _InputIterator>
__enable_if_t<!__same_value_type< _InputIterator >::value > | _M_insert_range_unique (_InputIterator __first, _InputIterator __last)
template<typename _InputIterator>
__enable_if_t< __same_value_type< _InputIterator >::value > | _M_insert_range_unique (_InputIterator __first, _InputIterator __last)
template<typename _Arg>
pair< typename _Rb_tree< _Key, _Val, _KeyOfValue, _Compare, _Alloc >::iterator, bool > | _M_insert_unique (_Arg &&__v)
template<typename _Arg>
pair< iterator, bool > | _M_insert_unique (_Arg &&__x)
template<typename _Arg>
iterator | _M_insert_unique_ (const_iterator __pos, _Arg &&__x)
template<typename _Arg, typename _NodeGen>
iterator | _M_insert_unique_ (const_iterator __pos, _Arg &&__x, _NodeGen &)
const_iterator | begin () const noexcept
iterator | begin () noexcept
void | clear () noexcept
size_type | count (const key_type &__k) const
bool | empty () const noexcept
const_iterator | end () const noexcept
iterator | end () noexcept
pair< iterator, iterator > | equal_range (const key_type &__k)
pair< const_iterator, const_iterator > | equal_range (const key_type &__k) const
size_type | erase (const key_type &__x)
iterator | erase (const_iterator __first, const_iterator __last)
iterator | erase (const_iterator __position)
iterator | erase (iterator __position)
iterator | find (const key_type &__k)
const_iterator | find (const key_type &__k) const
allocator_type | get_allocator () const noexcept
_Compare | key_comp () const
iterator | lower_bound (const key_type &__k)
const_iterator | lower_bound (const key_type &__k) const
size_type | max_size () const noexcept
const_reverse_iterator | rbegin () const noexcept
reverse_iterator | rbegin () noexcept
const_reverse_iterator | rend () const noexcept
reverse_iterator | rend () noexcept
size_type | size () const noexcept
void | swap (_Rb_tree &__t) noexcept(/*conditional */)
iterator | upper_bound (const key_type &__k)
const_iterator | upper_bound (const key_type &__k) const

## Protected Types
typedef _Node_traits::_Base_ptr | _Base_ptr
typedef _Node_traits::_Header_t | _Header_t
typedef _Node_traits::_Node_ptr | _Node_ptr

## Protected Member Functions
_Base_ptr | _M_begin () const noexcept
_Node_ptr | _M_begin_node () const noexcept
template<bool _MoveValue, typename _NodeGen>
_Node_ptr | _M_clone_node (_Node_ptr __x, _NodeGen &__node_gen)
template<typename... _Args>
void | _M_construct_node (_Node_ptr __node, _Args &&... __args)
template<typename... _Args>
_Node_ptr | _M_create_node (_Args &&... __args)
void | _M_destroy_node (_Node_ptr __p) noexcept
void | _M_drop_node (_Node_ptr __p) noexcept
_Base_ptr | _M_end () const noexcept
_Node_ptr | _M_get_node ()
template<typename _Key1, typename _Key2>
bool | _M_key_compare (const _Key1 &__k1, const _Key2 &__k2) const
_Base_ptr | _M_leftmost () const noexcept
_Base_ptr & | _M_leftmost () noexcept
void | _M_put_node (_Node_ptr __p) noexcept
_Base_ptr | _M_rightmost () const noexcept
_Base_ptr & | _M_rightmost () noexcept
_Base_ptr | _M_root () const noexcept
_Base_ptr & | _M_root () noexcept

## Static Protected Member Functions
static const _Key & | _S_key (_Base_ptr __x)
static const _Key & | _S_key (_Node_ptr __x)
static const _Key & | _S_key (const _Node &__node)
static _Base_ptr | _S_left (_Base_ptr __x) noexcept
static _Node_ptr | _S_left (_Node_ptr __x)
static _Base_ptr | _S_right (_Base_ptr __x) noexcept
static _Node_ptr | _S_right (_Node_ptr __x) noexcept

## Protected Attributes
_Rb_tree_impl< _Compare > | _M_impl

## Detailed Description

template<class _Key, class _Value, class _KeyOfValue, class _Compare, class _Alloc = std::allocator<_Value>>
struct __gnu_cxx::rb_tree< _Key, _Value, _KeyOfValue, _Compare, _Alloc >

This is an SGI extension.

Todo
  Needs documentation! See http://gcc.gnu.org/onlinedocs/libstdc++/manual/documentation_style.html

Definition at line 81 of file rb_tree.

## Member Typedef Documentation

## ◆ __same_value_type

template<typename _Key, typename _Val, typename _KeyOfValue, typename _Compare, typename _Alloc = allocator<_Val>>
template<typename _Iter>

using std::_Rb_tree< _Key, _Val, _KeyOfValue, _Compare, _Alloc >::__same_value_type
| inherited

Definition at line 1738 of file stl_tree.h.

## ◆ _Base

template<class _Key, class _Value, class _KeyOfValue, class _Compare, class _Alloc = std::allocator<_Value>>

typedef std::_Rb_tree<_Key, _Value, _KeyOfValue, _Compare, _Alloc> __gnu_cxx::rb_tree< _Key, _Value, _KeyOfValue, _Compare, _Alloc >::_Base

Definition at line 84 of file rb_tree.

## ◆ _Base_ptr

template<typename _Key, typename _Val, typename _KeyOfValue, typename _Compare, typename _Alloc = allocator<_Val>>

typedef _Node_traits::_Base_ptr std::_Rb_tree< _Key, _Val, _KeyOfValue, _Compare, _Alloc >::_Base_ptr
| protectedinherited

Definition at line 1038 of file stl_tree.h.

## ◆ _Header_t

template<typename _Key, typename _Val, typename _KeyOfValue, typename _Compare, typename _Alloc = allocator<_Val>>

typedef _Node_traits::_Header_t std::_Rb_tree< _Key, _Val, _KeyOfValue, _Compare, _Alloc >::_Header_t
| protectedinherited

Definition at line 1294 of file stl_tree.h.

## ◆ _Node_ptr

template<typename _Key, typename _Val, typename _KeyOfValue, typename _Compare, typename _Alloc = allocator<_Val>>

typedef _Node_traits::_Node_ptr std::_Rb_tree< _Key, _Val, _KeyOfValue, _Compare, _Alloc >::_Node_ptr
| protectedinherited

Definition at line 1039 of file stl_tree.h.

## ◆ allocator_type

template<class _Key, class _Value, class _KeyOfValue, class _Compare, class _Alloc = std::allocator<_Value>>

typedef _Base::allocator_type __gnu_cxx::rb_tree< _Key, _Value, _KeyOfValue, _Compare, _Alloc >::allocator_type

Definition at line 85 of file rb_tree.

## ◆ const_iterator

template<typename _Key, typename _Val, typename _KeyOfValue, typename _Compare, typename _Alloc = allocator<_Val>>

typedef _Node_traits::_Const_iterator std::_Rb_tree< _Key, _Val, _KeyOfValue, _Compare, _Alloc >::const_iterator
| inherited

Definition at line 1447 of file stl_tree.h.

## ◆ const_pointer

template<typename _Key, typename _Val, typename _KeyOfValue, typename _Compare, typename _Alloc = allocator<_Val>>

typedef const value_type* std::_Rb_tree< _Key, _Val, _KeyOfValue, _Compare, _Alloc >::const_pointer
| inherited

Definition at line 1146 of file stl_tree.h.

## ◆ const_reference

template<typename _Key, typename _Val, typename _KeyOfValue, typename _Compare, typename _Alloc = allocator<_Val>>

typedef const value_type& std::_Rb_tree< _Key, _Val, _KeyOfValue, _Compare, _Alloc >::const_reference
| inherited

Definition at line 1148 of file stl_tree.h.

## ◆ const_reverse_iterator

template<typename _Key, typename _Val, typename _KeyOfValue, typename _Compare, typename _Alloc = allocator<_Val>>

typedef std::reverse_iterator<const_iterator> std::_Rb_tree< _Key, _Val, _KeyOfValue, _Compare, _Alloc >::const_reverse_iterator
| inherited

Definition at line 1450 of file stl_tree.h.

## ◆ difference_type

template<typename _Key, typename _Val, typename _KeyOfValue, typename _Compare, typename _Alloc = allocator<_Val>>

typedef ptrdiff_t std::_Rb_tree< _Key, _Val, _KeyOfValue, _Compare, _Alloc >::difference_type
| inherited

Definition at line 1150 of file stl_tree.h.

## ◆ iterator

template<typename _Key, typename _Val, typename _KeyOfValue, typename _Compare, typename _Alloc = allocator<_Val>>

typedef _Node_traits::_Iterator std::_Rb_tree< _Key, _Val, _KeyOfValue, _Compare, _Alloc >::iterator
| inherited

Definition at line 1446 of file stl_tree.h.

## ◆ key_type

template<typename _Key, typename _Val, typename _KeyOfValue, typename _Compare, typename _Alloc = allocator<_Val>>

typedef _Key std::_Rb_tree< _Key, _Val, _KeyOfValue, _Compare, _Alloc >::key_type
| inherited

Definition at line 1143 of file stl_tree.h.

## ◆ pointer

template<typename _Key, typename _Val, typename _KeyOfValue, typename _Compare, typename _Alloc = allocator<_Val>>

typedef value_type* std::_Rb_tree< _Key, _Val, _KeyOfValue, _Compare, _Alloc >::pointer
| inherited

Definition at line 1145 of file stl_tree.h.

## ◆ reference

template<typename _Key, typename _Val, typename _KeyOfValue, typename _Compare, typename _Alloc = allocator<_Val>>

typedef value_type& std::_Rb_tree< _Key, _Val, _KeyOfValue, _Compare, _Alloc >::reference
| inherited

Definition at line 1147 of file stl_tree.h.

## ◆ reverse_iterator

template<typename _Key, typename _Val, typename _KeyOfValue, typename _Compare, typename _Alloc = allocator<_Val>>

typedef std::reverse_iterator<iterator> std::_Rb_tree< _Key, _Val, _KeyOfValue, _Compare, _Alloc >::reverse_iterator
| inherited

Definition at line 1449 of file stl_tree.h.

## ◆ size_type

template<typename _Key, typename _Val, typename _KeyOfValue, typename _Compare, typename _Alloc = allocator<_Val>>

typedef size_t std::_Rb_tree< _Key, _Val, _KeyOfValue, _Compare, _Alloc >::size_type
| inherited

Definition at line 1149 of file stl_tree.h.

## ◆ value_type

template<typename _Key, typename _Val, typename _KeyOfValue, typename _Compare, typename _Alloc = allocator<_Val>>

typedef _Val std::_Rb_tree< _Key, _Val, _KeyOfValue, _Compare, _Alloc >::value_type
| inherited

Definition at line 1144 of file stl_tree.h.

## Constructor & Destructor Documentation

## ◆ rb_tree()

template<class _Key, class _Value, class _KeyOfValue, class _Compare, class _Alloc = std::allocator<_Value>>

__gnu_cxx::rb_tree< _Key, _Value, _KeyOfValue, _Compare, _Alloc >::rb_tree | ( | const _Compare & | __comp = _Compare(),
|  | const allocator_type & | __a = allocator_type() )
| inline

Definition at line 87 of file rb_tree.

## ◆ ~rb_tree()

template<class _Key, class _Value, class _KeyOfValue, class _Compare, class _Alloc = std::allocator<_Value>>

__gnu_cxx::rb_tree< _Key, _Value, _KeyOfValue, _Compare, _Alloc >::~rb_tree | ( |  | ) |
| inline

Definition at line 91 of file rb_tree.

## Member Function Documentation

## ◆ __rb_verify()

template<typename _Key, typename _Val, typename _KeyOfValue, typename _Compare, typename _Alloc>

bool std::_Rb_tree< _Key, _Val, _KeyOfValue, _Compare, _Alloc >::__rb_verify | ( |  | ) | const
| inherited

Definition at line 3421 of file stl_tree.h.

## ◆ _M_assign_equal()

template<typename _Key, typename _Val, typename _KeyOfValue, typename _Compare, typename _Alloc>
template<typename _Iterator>

void std::_Rb_tree< _Key, _Val, _KeyOfValue, _Compare, _Alloc >::_M_assign_equal | ( | _Iterator | __first,
|  | _Iterator | __last )
| inherited

Definition at line 2472 of file stl_tree.h.

## ◆ _M_assign_unique()

template<typename _Key, typename _Val, typename _KeyOfValue, typename _Compare, typename _Alloc>
template<typename _Iterator>

void std::_Rb_tree< _Key, _Val, _KeyOfValue, _Compare, _Alloc >::_M_assign_unique | ( | _Iterator | __first,
|  | _Iterator | __last )
| inherited

Definition at line 2459 of file stl_tree.h.

## ◆ _M_begin()

template<typename _Key, typename _Val, typename _KeyOfValue, typename _Compare, typename _Alloc = allocator<_Val>>

_Base_ptr std::_Rb_tree< _Key, _Val, _KeyOfValue, _Compare, _Alloc >::_M_begin | ( |  | ) | const
| inlineprotectednoexceptinherited

Definition at line 1377 of file stl_tree.h.

## ◆ _M_begin_node()

template<typename _Key, typename _Val, typename _KeyOfValue, typename _Compare, typename _Alloc = allocator<_Val>>

_Node_ptr std::_Rb_tree< _Key, _Val, _KeyOfValue, _Compare, _Alloc >::_M_begin_node | ( |  | ) | const
| inlineprotectednoexceptinherited

Definition at line 1381 of file stl_tree.h.

## ◆ _M_clone_node()

template<typename _Key, typename _Val, typename _KeyOfValue, typename _Compare, typename _Alloc = allocator<_Val>>
template<bool _MoveValue, typename _NodeGen>

_Node_ptr std::_Rb_tree< _Key, _Val, _KeyOfValue, _Compare, _Alloc >::_M_clone_node | ( | _Node_ptr | __x,
|  | _NodeGen & | __node_gen )
| inlineprotectedinherited

Definition at line 1279 of file stl_tree.h.

## ◆ _M_construct_node()

template<typename _Key, typename _Val, typename _KeyOfValue, typename _Compare, typename _Alloc = allocator<_Val>>
template<typename... _Args>

void std::_Rb_tree< _Key, _Val, _KeyOfValue, _Compare, _Alloc >::_M_construct_node | ( | _Node_ptr | __node,
|  | _Args &&... | __args )
| inlineprotectedinherited

Definition at line 1232 of file stl_tree.h.

## ◆ _M_create_node()

template<typename _Key, typename _Val, typename _KeyOfValue, typename _Compare, typename _Alloc = allocator<_Val>>
template<typename... _Args>

_Node_ptr std::_Rb_tree< _Key, _Val, _KeyOfValue, _Compare, _Alloc >::_M_create_node | ( | _Args &&... | __args | ) |
| inlineprotectedinherited

Definition at line 1251 of file stl_tree.h.

## ◆ _M_destroy_node()

template<typename _Key, typename _Val, typename _KeyOfValue, typename _Compare, typename _Alloc = allocator<_Val>>

void std::_Rb_tree< _Key, _Val, _KeyOfValue, _Compare, _Alloc >::_M_destroy_node | ( | _Node_ptr | __p | ) |
| inlineprotectednoexceptinherited

Definition at line 1260 of file stl_tree.h.

## ◆ _M_drop_node()

template<typename _Key, typename _Val, typename _KeyOfValue, typename _Compare, typename _Alloc = allocator<_Val>>

void std::_Rb_tree< _Key, _Val, _KeyOfValue, _Compare, _Alloc >::_M_drop_node | ( | _Node_ptr | __p | ) |
| inlineprotectednoexceptinherited

Definition at line 1271 of file stl_tree.h.

## ◆ _M_emplace_equal()

template<typename _Key, typename _Val, typename _KeyOfValue, typename _Compare, typename _Alloc>
template<typename... _Args>

auto std::_Rb_tree< _Key, _Val, _KeyOfValue, _Compare, _Alloc >::_M_emplace_equal | ( | _Args &&... | __args | ) | -> iterator
| inherited

Definition at line 3254 of file stl_tree.h.

## ◆ _M_emplace_here()

template<typename _Key, typename _Val, typename _KeyOfValue, typename _Compare, typename _Alloc>
template<typename... _Args>

auto std::_Rb_tree< _Key, _Val, _KeyOfValue, _Compare, _Alloc >::_M_emplace_here | ( | bool | __place_left,
|  | _Base_ptr | __node,
|  | _Args &&... | __args ) -> iterator
| inherited

Definition at line 3298 of file stl_tree.h.

## ◆ _M_emplace_hint_equal()

template<typename _Key, typename _Val, typename _KeyOfValue, typename _Compare, typename _Alloc>
template<typename... _Args>

auto std::_Rb_tree< _Key, _Val, _KeyOfValue, _Compare, _Alloc >::_M_emplace_hint_equal | ( | const_iterator | __pos,
|  | _Args &&... | __args ) -> iterator
| inherited

Definition at line 3282 of file stl_tree.h.

## ◆ _M_emplace_hint_unique()

template<typename _Key, typename _Val, typename _KeyOfValue, typename _Compare, typename _Alloc>
template<typename... _Args>

auto std::_Rb_tree< _Key, _Val, _KeyOfValue, _Compare, _Alloc >::_M_emplace_hint_unique | ( | const_iterator | __pos,
|  | _Args &&... | __args ) -> iterator
| inherited

Definition at line 3267 of file stl_tree.h.

## ◆ _M_emplace_unique()

template<typename _Key, typename _Val, typename _KeyOfValue, typename _Compare, typename _Alloc>
template<typename... _Args>

auto std::_Rb_tree< _Key, _Val, _KeyOfValue, _Compare, _Alloc >::_M_emplace_unique | ( | _Args &&... | __args | ) | -> pair< iterator, bool >
| inherited

Definition at line 3239 of file stl_tree.h.

## ◆ _M_end()

template<typename _Key, typename _Val, typename _KeyOfValue, typename _Compare, typename _Alloc = allocator<_Val>>

_Base_ptr std::_Rb_tree< _Key, _Val, _KeyOfValue, _Compare, _Alloc >::_M_end | ( |  | ) | const
| inlineprotectednoexceptinherited

Definition at line 1390 of file stl_tree.h.

## ◆ _M_erase_tr()

template<typename _Key, typename _Val, typename _KeyOfValue, typename _Compare, typename _Alloc>
template<typename _Kt>

_Rb_tree< _Key, _Val, _KeyOfValue, _Compare, _Alloc >::size_type std::_Rb_tree< _Key, _Val, _KeyOfValue, _Compare, _Alloc >::_M_erase_tr | ( | const _Kt & | __x | ) |
| inherited

Definition at line 3356 of file stl_tree.h.

## ◆ _M_erase_unique()

template<typename _Key, typename _Val, typename _KeyOfValue, typename _Compare, typename _Alloc>

_Rb_tree< _Key, _Val, _KeyOfValue, _Compare, _Alloc >::size_type std::_Rb_tree< _Key, _Val, _KeyOfValue, _Compare, _Alloc >::_M_erase_unique | ( | const key_type & | __x | ) |
| inherited

Definition at line 3368 of file stl_tree.h.

## ◆ _M_get_insert_equal_pos()

template<typename _Key, typename _Val, typename _KeyOfValue, typename _Compare, typename _Alloc>

pair< typename _Rb_tree< _Key, _Val, _KeyOfValue, _Compare, _Alloc >::_Base_ptr, typename _Rb_tree< _Key, _Val, _KeyOfValue, _Compare, _Alloc >::_Base_ptr > std::_Rb_tree< _Key, _Val, _KeyOfValue, _Compare, _Alloc >::_M_get_insert_equal_pos | ( | const key_type & | __k | ) |
| inherited

Definition at line 2850 of file stl_tree.h.

## ◆ _M_get_insert_hint_equal_pos()

template<typename _Key, typename _Val, typename _KeyOfValue, typename _Compare, typename _Alloc>

pair< typename _Rb_tree< _Key, _Val, _KeyOfValue, _Compare, _Alloc >::_Base_ptr, typename _Rb_tree< _Key, _Val, _KeyOfValue, _Compare, _Alloc >::_Base_ptr > std::_Rb_tree< _Key, _Val, _KeyOfValue, _Compare, _Alloc >::_M_get_insert_hint_equal_pos | ( | const_iterator | __pos,
|  | const key_type & | __k )
| inherited

Definition at line 3106 of file stl_tree.h.

## ◆ _M_get_insert_hint_unique_pos()

template<typename _Key, typename _Val, typename _KeyOfValue, typename _Compare, typename _Alloc>

pair< typename _Rb_tree< _Key, _Val, _KeyOfValue, _Compare, _Alloc >::_Base_ptr, typename _Rb_tree< _Key, _Val, _KeyOfValue, _Compare, _Alloc >::_Base_ptr > std::_Rb_tree< _Key, _Val, _KeyOfValue, _Compare, _Alloc >::_M_get_insert_hint_unique_pos | ( | const_iterator | __pos,
|  | const key_type & | __k )
| inherited

Definition at line 2969 of file stl_tree.h.

## ◆ _M_get_insert_hint_unique_pos_tr()

template<typename _Key, typename _Val, typename _KeyOfValue, typename _Compare, typename _Alloc>
template<typename _Kt>

auto std::_Rb_tree< _Key, _Val, _KeyOfValue, _Compare, _Alloc >::_M_get_insert_hint_unique_pos_tr | ( | const_iterator | __hint,
|  | const _Kt & | __k ) -> pair< _Base_ptr, _Base_ptr >
| inherited

Definition at line 3025 of file stl_tree.h.

## ◆ _M_get_insert_unique_pos()

template<typename _Key, typename _Val, typename _KeyOfValue, typename _Compare, typename _Alloc>

pair< typename _Rb_tree< _Key, _Val, _KeyOfValue, _Compare, _Alloc >::_Base_ptr, typename _Rb_tree< _Key, _Val, _KeyOfValue, _Compare, _Alloc >::_Base_ptr > std::_Rb_tree< _Key, _Val, _KeyOfValue, _Compare, _Alloc >::_M_get_insert_unique_pos | ( | const key_type & | __k | ) |
| inherited

Definition at line 2818 of file stl_tree.h.

## ◆ _M_get_insert_unique_pos_tr()

template<typename _Key, typename _Val, typename _KeyOfValue, typename _Compare, typename _Alloc>
template<typename _Kt>

auto std::_Rb_tree< _Key, _Val, _KeyOfValue, _Compare, _Alloc >::_M_get_insert_unique_pos_tr | ( | const _Kt & | __k | ) | -> pair< _Base_ptr, _Base_ptr >
| inherited

Definition at line 2873 of file stl_tree.h.

## ◆ _M_get_node()

template<typename _Key, typename _Val, typename _KeyOfValue, typename _Compare, typename _Alloc = allocator<_Val>>

_Node_ptr std::_Rb_tree< _Key, _Val, _KeyOfValue, _Compare, _Alloc >::_M_get_node | ( |  | ) |
| inlineprotectedinherited

Definition at line 1167 of file stl_tree.h.

## ◆ _M_get_Node_allocator() [1/2]

template<typename _Key, typename _Val, typename _KeyOfValue, typename _Compare, typename _Alloc = allocator<_Val>>

const _Node_allocator & std::_Rb_tree< _Key, _Val, _KeyOfValue, _Compare, _Alloc >::_M_get_Node_allocator | ( |  | ) | const
| inlinenoexceptinherited

Definition at line 1158 of file stl_tree.h.

## ◆ _M_get_Node_allocator() [2/2]

template<typename _Key, typename _Val, typename _KeyOfValue, typename _Compare, typename _Alloc = allocator<_Val>>

_Node_allocator & std::_Rb_tree< _Key, _Val, _KeyOfValue, _Compare, _Alloc >::_M_get_Node_allocator | ( |  | ) |
| inlinenoexceptinherited

Definition at line 1154 of file stl_tree.h.

## ◆ _M_insert_equal()

template<typename _Key, typename _Val, typename _KeyOfValue, typename _Compare, typename _Alloc>
template<typename _Arg>

_Rb_tree< _Key, _Val, _KeyOfValue, _Compare, _Alloc >::iterator std::_Rb_tree< _Key, _Val, _KeyOfValue, _Compare, _Alloc >::_M_insert_equal | ( | _Arg && | __x | ) |
| inherited

Definition at line 2949 of file stl_tree.h.

## ◆ _M_insert_equal_() [1/2]

template<typename _Key, typename _Val, typename _KeyOfValue, typename _Compare, typename _Alloc = allocator<_Val>>
template<typename _Arg>

iterator std::_Rb_tree< _Key, _Val, _KeyOfValue, _Compare, _Alloc >::_M_insert_equal_ | ( | const_iterator | __pos,
|  | _Arg && | __x )
| inlineinherited

Definition at line 1715 of file stl_tree.h.

## ◆ _M_insert_equal_() [2/2]

template<typename _Key, typename _Val, typename _KeyOfValue, typename _Compare, typename _Alloc>
template<typename _Arg, typename _NodeGen>

_Rb_tree< _Key, _Val, _KeyOfValue, _Compare, _Alloc >::iterator std::_Rb_tree< _Key, _Val, _KeyOfValue, _Compare, _Alloc >::_M_insert_equal_ | ( | const_iterator | __pos,
|  | _Arg && | __x,
|  | _NodeGen & | __node_gen )
| inherited

Definition at line 3162 of file stl_tree.h.

## ◆ _M_insert_range_equal() [1/2]

template<typename _Key, typename _Val, typename _KeyOfValue, typename _Compare, typename _Alloc = allocator<_Val>>
template<typename _InputIterator>

__enable_if_t<!__same_value_type< _InputIterator >::value > std::_Rb_tree< _Key, _Val, _KeyOfValue, _Compare, _Alloc >::_M_insert_range_equal | ( | _InputIterator | __first,
|  | _InputIterator | __last )
| inlineinherited

Definition at line 1768 of file stl_tree.h.

## ◆ _M_insert_range_equal() [2/2]

template<typename _Key, typename _Val, typename _KeyOfValue, typename _Compare, typename _Alloc = allocator<_Val>>
template<typename _InputIterator>

__enable_if_t< __same_value_type< _InputIterator >::value > std::_Rb_tree< _Key, _Val, _KeyOfValue, _Compare, _Alloc >::_M_insert_range_equal | ( | _InputIterator | __first,
|  | _InputIterator | __last )
| inlineinherited

Definition at line 1759 of file stl_tree.h.

## ◆ _M_insert_range_unique() [1/2]

template<typename _Key, typename _Val, typename _KeyOfValue, typename _Compare, typename _Alloc = allocator<_Val>>
template<typename _InputIterator>

__enable_if_t<!__same_value_type< _InputIterator >::value > std::_Rb_tree< _Key, _Val, _KeyOfValue, _Compare, _Alloc >::_M_insert_range_unique | ( | _InputIterator | __first,
|  | _InputIterator | __last )
| inlineinherited

Definition at line 1751 of file stl_tree.h.

## ◆ _M_insert_range_unique() [2/2]

template<typename _Key, typename _Val, typename _KeyOfValue, typename _Compare, typename _Alloc = allocator<_Val>>
template<typename _InputIterator>

__enable_if_t< __same_value_type< _InputIterator >::value > std::_Rb_tree< _Key, _Val, _KeyOfValue, _Compare, _Alloc >::_M_insert_range_unique | ( | _InputIterator | __first,
|  | _InputIterator | __last )
| inlineinherited

Definition at line 1742 of file stl_tree.h.

## ◆ _M_insert_unique()

template<typename _Key, typename _Val, typename _KeyOfValue, typename _Compare, typename _Alloc = allocator<_Val>>
template<typename _Arg>

pair< typename _Rb_tree< _Key, _Val, _KeyOfValue, _Compare, _Alloc >::iterator, bool > std::_Rb_tree< _Key, _Val, _KeyOfValue, _Compare, _Alloc >::_M_insert_unique | ( | _Arg && | __v | ) |
| inherited

Definition at line 2921 of file stl_tree.h.

## ◆ _M_insert_unique_() [1/2]

template<typename _Key, typename _Val, typename _KeyOfValue, typename _Compare, typename _Alloc = allocator<_Val>>
template<typename _Arg>

iterator std::_Rb_tree< _Key, _Val, _KeyOfValue, _Compare, _Alloc >::_M_insert_unique_ | ( | const_iterator | __pos,
|  | _Arg && | __x )
| inlineinherited

Definition at line 1703 of file stl_tree.h.

## ◆ _M_insert_unique_() [2/2]

template<typename _Key, typename _Val, typename _KeyOfValue, typename _Compare, typename _Alloc>
template<typename _Arg, typename _NodeGen>

_Rb_tree< _Key, _Val, _KeyOfValue, _Compare, _Alloc >::iterator std::_Rb_tree< _Key, _Val, _KeyOfValue, _Compare, _Alloc >::_M_insert_unique_ | ( | const_iterator | __pos,
|  | _Arg && | __x,
|  | _NodeGen & | __node_gen )
| inherited

Definition at line 3081 of file stl_tree.h.

## ◆ _M_key_compare()

template<typename _Key, typename _Val, typename _KeyOfValue, typename _Compare, typename _Alloc = allocator<_Val>>
template<typename _Key1, typename _Key2>

bool std::_Rb_tree< _Key, _Val, _KeyOfValue, _Compare, _Alloc >::_M_key_compare | ( | const _Key1 & | __k1,
|  | const _Key2 & | __k2 ) const
| inlineprotectedinherited

Definition at line 1397 of file stl_tree.h.

## ◆ _M_leftmost() [1/2]

template<typename _Key, typename _Val, typename _KeyOfValue, typename _Compare, typename _Alloc = allocator<_Val>>

_Base_ptr std::_Rb_tree< _Key, _Val, _KeyOfValue, _Compare, _Alloc >::_M_leftmost | ( |  | ) | const
| inlineprotectednoexceptinherited

Definition at line 1365 of file stl_tree.h.

## ◆ _M_leftmost() [2/2]

template<typename _Key, typename _Val, typename _KeyOfValue, typename _Compare, typename _Alloc = allocator<_Val>>

_Base_ptr & std::_Rb_tree< _Key, _Val, _KeyOfValue, _Compare, _Alloc >::_M_leftmost | ( |  | ) |
| inlineprotectednoexceptinherited

Definition at line 1361 of file stl_tree.h.

## ◆ _M_put_node()

template<typename _Key, typename _Val, typename _KeyOfValue, typename _Compare, typename _Alloc = allocator<_Val>>

void std::_Rb_tree< _Key, _Val, _KeyOfValue, _Compare, _Alloc >::_M_put_node | ( | _Node_ptr | __p | ) |
| inlineprotectednoexceptinherited

Definition at line 1188 of file stl_tree.h.

## ◆ _M_rightmost() [1/2]

template<typename _Key, typename _Val, typename _KeyOfValue, typename _Compare, typename _Alloc = allocator<_Val>>

_Base_ptr std::_Rb_tree< _Key, _Val, _KeyOfValue, _Compare, _Alloc >::_M_rightmost | ( |  | ) | const
| inlineprotectednoexceptinherited

Definition at line 1373 of file stl_tree.h.

## ◆ _M_rightmost() [2/2]

template<typename _Key, typename _Val, typename _KeyOfValue, typename _Compare, typename _Alloc = allocator<_Val>>

_Base_ptr & std::_Rb_tree< _Key, _Val, _KeyOfValue, _Compare, _Alloc >::_M_rightmost | ( |  | ) |
| inlineprotectednoexceptinherited

Definition at line 1369 of file stl_tree.h.

## ◆ _M_root() [1/2]

template<typename _Key, typename _Val, typename _KeyOfValue, typename _Compare, typename _Alloc = allocator<_Val>>

_Base_ptr std::_Rb_tree< _Key, _Val, _KeyOfValue, _Compare, _Alloc >::_M_root | ( |  | ) | const
| inlineprotectednoexceptinherited

Definition at line 1357 of file stl_tree.h.

## ◆ _M_root() [2/2]

template<typename _Key, typename _Val, typename _KeyOfValue, typename _Compare, typename _Alloc = allocator<_Val>>

_Base_ptr & std::_Rb_tree< _Key, _Val, _KeyOfValue, _Compare, _Alloc >::_M_root | ( |  | ) |
| inlineprotectednoexceptinherited

Definition at line 1353 of file stl_tree.h.

## ◆ _S_key() [1/3]

template<typename _Key, typename _Val, typename _KeyOfValue, typename _Compare, typename _Alloc = allocator<_Val>>

const _Key & std::_Rb_tree< _Key, _Val, _KeyOfValue, _Compare, _Alloc >::_S_key | ( | _Base_ptr | __x | ) |
| inlinestaticprotectedinherited

Definition at line 1414 of file stl_tree.h.

## ◆ _S_key() [2/3]

template<typename _Key, typename _Val, typename _KeyOfValue, typename _Compare, typename _Alloc = allocator<_Val>>

const _Key & std::_Rb_tree< _Key, _Val, _KeyOfValue, _Compare, _Alloc >::_S_key | ( | _Node_ptr | __x | ) |
| inlinestaticprotectedinherited

Definition at line 1418 of file stl_tree.h.

## ◆ _S_key() [3/3]

template<typename _Key, typename _Val, typename _KeyOfValue, typename _Compare, typename _Alloc = allocator<_Val>>

const _Key & std::_Rb_tree< _Key, _Val, _KeyOfValue, _Compare, _Alloc >::_S_key | ( | const _Node & | __node | ) |
| inlinestaticprotectedinherited

Definition at line 1410 of file stl_tree.h.

## ◆ _S_left() [1/2]

template<typename _Key, typename _Val, typename _KeyOfValue, typename _Compare, typename _Alloc = allocator<_Val>>

_Base_ptr std::_Rb_tree< _Key, _Val, _KeyOfValue, _Compare, _Alloc >::_S_left | ( | _Base_ptr | __x | ) |
| inlinestaticprotectednoexceptinherited

Definition at line 1422 of file stl_tree.h.

## ◆ _S_left() [2/2]

template<typename _Key, typename _Val, typename _KeyOfValue, typename _Compare, typename _Alloc = allocator<_Val>>

_Node_ptr std::_Rb_tree< _Key, _Val, _KeyOfValue, _Compare, _Alloc >::_S_left | ( | _Node_ptr | __x | ) |
| inlinestaticprotectedinherited

Definition at line 1426 of file stl_tree.h.

## ◆ _S_right() [1/2]

template<typename _Key, typename _Val, typename _KeyOfValue, typename _Compare, typename _Alloc = allocator<_Val>>

_Base_ptr std::_Rb_tree< _Key, _Val, _KeyOfValue, _Compare, _Alloc >::_S_right | ( | _Base_ptr | __x | ) |
| inlinestaticprotectednoexceptinherited

Definition at line 1434 of file stl_tree.h.

## ◆ _S_right() [2/2]

template<typename _Key, typename _Val, typename _KeyOfValue, typename _Compare, typename _Alloc = allocator<_Val>>

_Node_ptr std::_Rb_tree< _Key, _Val, _KeyOfValue, _Compare, _Alloc >::_S_right | ( | _Node_ptr | __x | ) |
| inlinestaticprotectednoexceptinherited

Definition at line 1438 of file stl_tree.h.

## ◆ begin() [1/2]

template<typename _Key, typename _Val, typename _KeyOfValue, typename _Compare, typename _Alloc = allocator<_Val>>

const_iterator std::_Rb_tree< _Key, _Val, _KeyOfValue, _Compare, _Alloc >::begin | ( |  | ) | const
| inlinenoexceptinherited

Definition at line 1644 of file stl_tree.h.

## ◆ begin() [2/2]

template<typename _Key, typename _Val, typename _KeyOfValue, typename _Compare, typename _Alloc = allocator<_Val>>

iterator std::_Rb_tree< _Key, _Val, _KeyOfValue, _Compare, _Alloc >::begin | ( |  | ) |
| inlinenoexceptinherited

Definition at line 1640 of file stl_tree.h.

## ◆ clear()

template<typename _Key, typename _Val, typename _KeyOfValue, typename _Compare, typename _Alloc = allocator<_Val>>

void std::_Rb_tree< _Key, _Val, _KeyOfValue, _Compare, _Alloc >::clear | ( |  | ) |
| inlinenoexceptinherited

Definition at line 1902 of file stl_tree.h.

## ◆ count()

template<typename _Key, typename _Val, typename _KeyOfValue, typename _Compare, typename _Alloc>

_Rb_tree< _Key, _Val, _KeyOfValue, _Compare, _Alloc >::size_type std::_Rb_tree< _Key, _Val, _KeyOfValue, _Compare, _Alloc >::count | ( | const key_type & | __k | ) | const
| inherited

Definition at line 3406 of file stl_tree.h.

## ◆ empty()

template<typename _Key, typename _Val, typename _KeyOfValue, typename _Compare, typename _Alloc = allocator<_Val>>

bool std::_Rb_tree< _Key, _Val, _KeyOfValue, _Compare, _Alloc >::empty | ( |  | ) | const
| inlinenodiscardnoexceptinherited

Definition at line 1672 of file stl_tree.h.

## ◆ end() [1/2]

template<typename _Key, typename _Val, typename _KeyOfValue, typename _Compare, typename _Alloc = allocator<_Val>>

const_iterator std::_Rb_tree< _Key, _Val, _KeyOfValue, _Compare, _Alloc >::end | ( |  | ) | const
| inlinenoexceptinherited

Definition at line 1652 of file stl_tree.h.

## ◆ end() [2/2]

template<typename _Key, typename _Val, typename _KeyOfValue, typename _Compare, typename _Alloc = allocator<_Val>>

iterator std::_Rb_tree< _Key, _Val, _KeyOfValue, _Compare, _Alloc >::end | ( |  | ) |
| inlinenoexceptinherited

Definition at line 1648 of file stl_tree.h.

## ◆ equal_range() [1/2]

template<typename _Key, typename _Val, typename _KeyOfValue, typename _Compare, typename _Alloc>

pair< typename _Rb_tree< _Key, _Val, _KeyOfValue, _Compare, _Alloc >::iterator, typename _Rb_tree< _Key, _Val, _KeyOfValue, _Compare, _Alloc >::iterator > std::_Rb_tree< _Key, _Val, _KeyOfValue, _Compare, _Alloc >::equal_range | ( | const key_type & | __k | ) |
| inherited

Definition at line 2721 of file stl_tree.h.

## ◆ equal_range() [2/2]

template<typename _Key, typename _Val, typename _KeyOfValue, typename _Compare, typename _Alloc>

pair< typename _Rb_tree< _Key, _Val, _KeyOfValue, _Compare, _Alloc >::const_iterator, typename _Rb_tree< _Key, _Val, _KeyOfValue, _Compare, _Alloc >::const_iterator > std::_Rb_tree< _Key, _Val, _KeyOfValue, _Compare, _Alloc >::equal_range | ( | const key_type & | __k | ) | const
| inherited

Definition at line 2753 of file stl_tree.h.

## ◆ erase() [1/4]

template<typename _Key, typename _Val, typename _KeyOfValue, typename _Compare, typename _Alloc>

_Rb_tree< _Key, _Val, _KeyOfValue, _Compare, _Alloc >::size_type std::_Rb_tree< _Key, _Val, _KeyOfValue, _Compare, _Alloc >::erase | ( | const key_type & | __x | ) |
| inherited

Definition at line 3343 of file stl_tree.h.

## ◆ erase() [2/4]

template<typename _Key, typename _Val, typename _KeyOfValue, typename _Compare, typename _Alloc = allocator<_Val>>

iterator std::_Rb_tree< _Key, _Val, _KeyOfValue, _Compare, _Alloc >::erase | ( | const_iterator | __first,
|  | const_iterator | __last )
| inlineinherited

Definition at line 1886 of file stl_tree.h.

## ◆ erase() [3/4]

template<typename _Key, typename _Val, typename _KeyOfValue, typename _Compare, typename _Alloc = allocator<_Val>>

iterator std::_Rb_tree< _Key, _Val, _KeyOfValue, _Compare, _Alloc >::erase | ( | const_iterator | __position | ) |
| inlineinherited

Definition at line 1835 of file stl_tree.h.

## ◆ erase() [4/4]

template<typename _Key, typename _Val, typename _KeyOfValue, typename _Compare, typename _Alloc = allocator<_Val>>

iterator std::_Rb_tree< _Key, _Val, _KeyOfValue, _Compare, _Alloc >::erase | ( | iterator | __position | ) |
| inlineinherited

Definition at line 1847 of file stl_tree.h.

## ◆ find() [1/2]

template<typename _Key, typename _Val, typename _KeyOfValue, typename _Compare, typename _Alloc>

_Rb_tree< _Key, _Val, _KeyOfValue, _Compare, _Alloc >::iterator std::_Rb_tree< _Key, _Val, _KeyOfValue, _Compare, _Alloc >::find | ( | const key_type & | __k | ) |
| inherited

Definition at line 3383 of file stl_tree.h.

## ◆ find() [2/2]

template<typename _Key, typename _Val, typename _KeyOfValue, typename _Compare, typename _Alloc>

_Rb_tree< _Key, _Val, _KeyOfValue, _Compare, _Alloc >::const_iterator std::_Rb_tree< _Key, _Val, _KeyOfValue, _Compare, _Alloc >::find | ( | const key_type & | __k | ) | const
| inherited

Definition at line 3395 of file stl_tree.h.

## ◆ get_allocator()

template<typename _Key, typename _Val, typename _KeyOfValue, typename _Compare, typename _Alloc = allocator<_Val>>

allocator_type std::_Rb_tree< _Key, _Val, _KeyOfValue, _Compare, _Alloc >::get_allocator | ( |  | ) | const
| inlinenoexceptinherited

Definition at line 1162 of file stl_tree.h.

## ◆ key_comp()

template<typename _Key, typename _Val, typename _KeyOfValue, typename _Compare, typename _Alloc = allocator<_Val>>

_Compare std::_Rb_tree< _Key, _Val, _KeyOfValue, _Compare, _Alloc >::key_comp | ( |  | ) | const
| inlineinherited

Definition at line 1636 of file stl_tree.h.

## ◆ lower_bound() [1/2]

template<typename _Key, typename _Val, typename _KeyOfValue, typename _Compare, typename _Alloc = allocator<_Val>>

iterator std::_Rb_tree< _Key, _Val, _KeyOfValue, _Compare, _Alloc >::lower_bound | ( | const key_type & | __k | ) |
| inlineinherited

Definition at line 1919 of file stl_tree.h.

## ◆ lower_bound() [2/2]

template<typename _Key, typename _Val, typename _KeyOfValue, typename _Compare, typename _Alloc = allocator<_Val>>

const_iterator std::_Rb_tree< _Key, _Val, _KeyOfValue, _Compare, _Alloc >::lower_bound | ( | const key_type & | __k | ) | const
| inlineinherited

Definition at line 1923 of file stl_tree.h.

## ◆ max_size()

template<typename _Key, typename _Val, typename _KeyOfValue, typename _Compare, typename _Alloc = allocator<_Val>>

size_type std::_Rb_tree< _Key, _Val, _KeyOfValue, _Compare, _Alloc >::max_size | ( |  | ) | const
| inlinenoexceptinherited

Definition at line 1680 of file stl_tree.h.

## ◆ rbegin() [1/2]

template<typename _Key, typename _Val, typename _KeyOfValue, typename _Compare, typename _Alloc = allocator<_Val>>

const_reverse_iterator std::_Rb_tree< _Key, _Val, _KeyOfValue, _Compare, _Alloc >::rbegin | ( |  | ) | const
| inlinenoexceptinherited

Definition at line 1660 of file stl_tree.h.

## ◆ rbegin() [2/2]

template<typename _Key, typename _Val, typename _KeyOfValue, typename _Compare, typename _Alloc = allocator<_Val>>

reverse_iterator std::_Rb_tree< _Key, _Val, _KeyOfValue, _Compare, _Alloc >::rbegin | ( |  | ) |
| inlinenoexceptinherited

Definition at line 1656 of file stl_tree.h.

## ◆ rend() [1/2]

template<typename _Key, typename _Val, typename _KeyOfValue, typename _Compare, typename _Alloc = allocator<_Val>>

const_reverse_iterator std::_Rb_tree< _Key, _Val, _KeyOfValue, _Compare, _Alloc >::rend | ( |  | ) | const
| inlinenoexceptinherited

Definition at line 1668 of file stl_tree.h.

## ◆ rend() [2/2]

template<typename _Key, typename _Val, typename _KeyOfValue, typename _Compare, typename _Alloc = allocator<_Val>>

reverse_iterator std::_Rb_tree< _Key, _Val, _KeyOfValue, _Compare, _Alloc >::rend | ( |  | ) |
| inlinenoexceptinherited

Definition at line 1664 of file stl_tree.h.

## ◆ size()

template<typename _Key, typename _Val, typename _KeyOfValue, typename _Compare, typename _Alloc = allocator<_Val>>

size_type std::_Rb_tree< _Key, _Val, _KeyOfValue, _Compare, _Alloc >::size | ( |  | ) | const
| inlinenoexceptinherited

Definition at line 1676 of file stl_tree.h.

## ◆ swap()

template<typename _Key, typename _Val, typename _KeyOfValue, typename _Compare, typename _Alloc>

void std::_Rb_tree< _Key, _Val, _KeyOfValue, _Compare, _Alloc >::swap | ( | _Rb_tree< _Key, _Val, _KeyOfValue, _Compare, _Alloc > & | __t | ) |
| noexceptinherited

Definition at line 2782 of file stl_tree.h.

## ◆ upper_bound() [1/2]

template<typename _Key, typename _Val, typename _KeyOfValue, typename _Compare, typename _Alloc = allocator<_Val>>

iterator std::_Rb_tree< _Key, _Val, _KeyOfValue, _Compare, _Alloc >::upper_bound | ( | const key_type & | __k | ) |
| inlineinherited

Definition at line 1930 of file stl_tree.h.

## ◆ upper_bound() [2/2]

template<typename _Key, typename _Val, typename _KeyOfValue, typename _Compare, typename _Alloc = allocator<_Val>>

const_iterator std::_Rb_tree< _Key, _Val, _KeyOfValue, _Compare, _Alloc >::upper_bound | ( | const key_type & | __k | ) | const
| inlineinherited

Definition at line 1934 of file stl_tree.h.

## Member Data Documentation

## ◆ _M_impl

template<typename _Key, typename _Val, typename _KeyOfValue, typename _Compare, typename _Alloc = allocator<_Val>>

_Rb_tree_impl<_Compare> std::_Rb_tree< _Key, _Val, _KeyOfValue, _Compare, _Alloc >::_M_impl
| protectedinherited

Definition at line 1349 of file stl_tree.h.

The documentation for this struct was generated from the following file:

- rb_tree